import java.net.ServerSocket;
import java.net.Socket;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.PrintWriter;
import java.io.IOException;

class EncodeHandler extends Thread {
	private Socket incoming;
	private int number;

	public EncodeHandler(Socket i, int n) {
		incoming = i;
		number = n;
	}
	public void run() {
		try {
			InputStreamReader isr = new InputStreamReader(incoming.getInputStream());
			BufferedReader in = new BufferedReader(isr);
			PrintWriter out = new PrintWriter(incoming.getOutputStream(), true);

			out.println("Hello, client No." + number + "! Enter 'Bye' to exit.");

			while (true) {
				String str = in.readLine();
				System.out.println(str);
				if (str != null) {
					if (str.toUpperCase().equals("BYE")) {
						out.println("Good bye!");
						break;
					}
					String s = "";
					for (int i=0; i<str.length(); i++) {
						char c = str.charAt(i);
						if (((c >= 'A') && (c <= 'Z')) || ((c >= 'a') && (c <= 'z'))) {
							switch (c) {
								case 'z': c = 'a';
													break;
								case 'Z': c = 'A';
													break;
								default: c++;
							}
						}
						s += c;
					}
					out.println("(client No." + number + "):" + s);
				}
			}
			incoming.close();
		} catch (Exception e) {
			System.out.println(e);
		}
	}
}
public class EncodeThreadServer {
	public static void main(String[] args) {
		int n = 1;

		try {
			ServerSocket server = new ServerSocket(1000);
			while (true) {
				Socket incoming = server.accept();
				System.out.println("accept client No." + n);
				new EncodeHandler(incoming, n).start();
				n++;
			}
		} catch (Exception e) {
			System.err.println("åȺ˥顼ȯޤ: " + e);
		}
	}
}
