import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.HyperlinkEvent;
import java.awt.Container;
import java.awt.Color;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JFrame;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import java.io.IOException;

class TinyBrowser extends JFrame implements ActionListener, HyperlinkListener {
	JTextField url;
	JEditorPane jep;

	public TinyBrowser() {
		super("Tiny Browser");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container pane = getContentPane();

		JPanel panel = new JPanel();
		JLabel label = new JLabel("URL: ");
		String home = "http://www.gihyo.co.jp";
		url = new JTextField(home, 40);
		label.setLabelFor(url);
		url.addActionListener(this);
		panel.add(label);
		panel.add(url);
		pane.add(BorderLayout.NORTH, panel);

		try {
			jep = new JEditorPane(home);
		} catch (IOException ioe) {
			jep = new JEditorPane();
		}
		jep.setEditable(false);
		jep.addHyperlinkListener(this);
		JScrollPane jsp = new JScrollPane(jep);
		pane.add(BorderLayout.CENTER, jsp);

		setSize(640, 480);
		setVisible(true);
	}
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == url) {
			try {
				jep.setPage(url.getText());
			} catch (IOException ie) {
				ie.printStackTrace();
			}
		}
	}
	public void hyperlinkUpdate(HyperlinkEvent e) {
		if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
			try {
				url.setText(e.getURL().toString());
				jep.setPage(e.getURL());
			} catch (IOException ioe) {
				ioe.printStackTrace();
			}
		}
	}
	public static void main(String[] args) {
		TinyBrowser b = new TinyBrowser();
	}
}
