import java.net.ServerSocket;
import java.net.Socket;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.PrintWriter;
import java.io.IOException;

class UpperCaseHandler extends Thread {
	private Socket incoming;
	private int number;

	public UpperCaseHandler(Socket i, int n) {
		incoming = i;
		number = n;
	}
	public void run() {
		try {
			InputStreamReader isr = new InputStreamReader(incoming.getInputStream());
			BufferedReader in = new BufferedReader(isr);
			PrintWriter out = new PrintWriter(incoming.getOutputStream(), true);

			out.println("Hello, client No." + number + "! Enter 'Bye' to exit.");

			while (true) {
				String str = in.readLine();
				System.out.println(str);
				if (str != null) {
					if (str.toUpperCase().equals("BYE")) {
						out.println("Good bye!");
						break;
					}
					out.println("(client No." + number + "):" + str.toUpperCase());
				}
			}
			incoming.close();
		} catch (Exception e) {
			System.out.println(e);
		}
	}
}
class UpperCaseThreadServer {
	public static void main(String[] args) {
		int n = 1;

		try {
			ServerSocket server = new ServerSocket(1000);
			while (true) {
				Socket incoming = server.accept();
				System.out.println("accept client No." + n);
				new UpperCaseHandler(incoming, n).start();
				n++;
			}
		} catch (Exception e) {
			System.err.println("åȺ˥顼ȯޤ: " + e);
		}
	}
}
